Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3178)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3182)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! * Adjustment to new Inifor version: 
+!   - No vertical interpolation/extrapolation of lateral boundary data required
+!     any more (Inifor can treat grid stretching now
+!   - Revise initialization in case of COSMO forcing 
+! * Rename variables and subroutines for offline nesting
 ! 
 ! Former revisions:
@@ -69,24 +73,22 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, heatflux_input_conversion, pt, pt_init, q, q_init, s,   &
-               tend, u, u_init, ug, v, v_init, vg, w, w_subs,                  &
+        ONLY:  dzw, e, diss, heatflux_input_conversion, pt, pt_init, q,        &
+               q_init, s, tend, u, u_init, ug, v, v_init, vg, w, w_subs,       &
                waterflux_input_conversion, zu, zw                  
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr, bc_ns, bc_pt_b, bc_q_b, constant_diffusion,              &
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, &
+               bc_lr, bc_ns, bc_pt_b, bc_q_b, constant_diffusion,              &
                constant_heatflux, constant_waterflux,                          &
-               data_output_pr, dt_3d, end_time, forcing,                       &
-               force_bound_l, force_bound_n, force_bound_r, force_bound_s,     &  
+               data_output_pr, dt_3d, end_time,                                &
                humidity, initializing_actions, intermediate_timestep_count,    &
                ibc_pt_b, ibc_q_b,                                              &
                large_scale_forcing, large_scale_subsidence, lsf_surf, lsf_vert,&
-               lsf_exception, message_string, neutral, nudging, passive_scalar,&
-               pt_surface, ocean, q_surface, surface_heatflux,                 &
-               surface_pressure, surface_waterflux, topography,                &
-               use_subsidence_tendencies
+               lsf_exception, message_string, nesting_offline, neutral,        &
+               nudging, passive_scalar, pt_surface, ocean, q_surface,          &
+               surface_heatflux, surface_pressure, surface_waterflux,          &
+               topography, use_subsidence_tendencies
 
     USE grid_variables
-
-    USE pegrid
 
     USE indices,                                                               &
@@ -96,4 +98,9 @@
     USE kinds
 
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  nest_offl
+
+    USE pegrid
+
     USE surface_mod,                                                           &
         ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
@@ -101,7 +108,4 @@
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions, sums_ls_l, weight_substep
-
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  force, netcdf_data_input_interpolate
 
     INTEGER(iwp) ::  nlsf = 1000                       !< maximum number of profiles in LSF_DATA (large scale forcing)
@@ -140,13 +144,14 @@
 !
 !-- Public subroutines
-    PUBLIC ls_forcing_surf, ls_forcing_vert, ls_advec, lsf_init,               &
+    PUBLIC calc_tnudge, ls_forcing_surf, ls_forcing_vert, ls_advec, lsf_init,  &
            lsf_nudging_check_parameters, nudge_init,                           &
            lsf_nudging_check_data_output_pr, lsf_nudging_header,               &
-           calc_tnudge, nudge, nudge_ref, forcing_bc_mass_conservation,        &
-           forcing_bc
+           lsf_nesting_offline, lsf_nesting_offline_mass_conservation,         & 
+           nudge, nudge_ref
+           
 !
 !-- Public variables
     PUBLIC qsws_surf, shf_surf, td_lsa_lpt, td_lsa_q, td_sub_lpt,              &
-           td_sub_q, time_vert, force
+           td_sub_q, time_vert
 
 
@@ -167,7 +172,12 @@
 ! Description:
 ! ------------
-!> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
-    SUBROUTINE forcing_bc_mass_conservation
+!> In this subroutine a constant mass within the model domain is guaranteed. 
+!> Larger-scale models may be based on a compressible equation system, which is
+!> not consistent with PALMs incompressible equation system. In order to avoid
+!> a decrease or increase of mass during the simulation, non-divergent flow
+!> through the lateral and top boundaries is compensated by the vertical wind 
+!> component at the top boundary. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE lsf_nesting_offline_mass_conservation
 
        USE control_parameters,                                                 &
@@ -176,10 +186,10 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !<
-       INTEGER(iwp) ::  j !<
-       INTEGER(iwp) ::  k !<
-
-       REAL(wp) ::  w_correct !< 
-       REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !<
+       INTEGER(iwp) ::  i !< grid index in x-direction
+       INTEGER(iwp) ::  j !< grid index in y-direction
+       INTEGER(iwp) ::  k !< grid index in z-direction
+
+       REAL(wp) ::  w_correct                       !< vertical velocity increment required to compensate non-divergent flow through the boundaries
+       REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !< local volume flow
 
        volume_flow   = 0.0_wp
@@ -188,5 +198,5 @@
        d_area_t = 1.0_wp / ( ( nx + 1 ) * dx * ( ny + 1 ) * dy )
 
-       IF ( force_bound_l )  THEN
+       IF ( bc_dirichlet_l )  THEN
           i = nxl
           DO  j = nys, nyn
@@ -198,5 +208,5 @@
           ENDDO
        ENDIF
-       IF ( force_bound_r )  THEN
+       IF ( bc_dirichlet_r )  THEN
           i = nxr+1
           DO  j = nys, nyn
@@ -208,5 +218,5 @@
           ENDDO
        ENDIF
-       IF ( force_bound_s )  THEN
+       IF ( bc_dirichlet_s )  THEN
           j = nys
           DO  i = nxl, nxr
@@ -218,5 +228,5 @@
           ENDDO
        ENDIF
-       IF ( force_bound_n )  THEN
+       IF ( bc_dirichlet_n )  THEN
           j = nyn+1
           DO  i = nxl, nxr
@@ -255,8 +265,5 @@
        ENDDO
 
-write(9,*) "w correction", w_correct
-flush(9)
-
-    END SUBROUTINE forcing_bc_mass_conservation
+    END SUBROUTINE lsf_nesting_offline_mass_conservation
 
 
@@ -264,14 +271,13 @@
 ! Description:
 ! ------------
-!> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
-    SUBROUTINE forcing_bc
+!> Set the lateral and top boundary conditions in case the PALM domain is 
+!> nested offline in a mesoscale model. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE lsf_nesting_offline
 
        USE control_parameters,                                                 &
-           ONLY:  force_bound_l, force_bound_n, force_bound_r, force_bound_s,  &
-                  humidity, neutral, passive_scalar, simulated_time
-
-       USE netcdf_data_input_mod,                                              &
-           ONLY:  force                              
+           ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,              &
+                  bc_dirichlet_s, humidity, neutral, passive_scalar, rans_mode,&
+                  rans_tke_e, time_since_reference_point                      
 
        IMPLICIT NONE
@@ -284,133 +290,44 @@
        REAL(wp) ::  ddt_lsf !< inverse value of time resolution of forcing data
        REAL(wp) ::  t_ref   !< time past since last reference step
-
-!
-!--    If required, interpolate and/or extrapolate data vertically. This is 
-!--    required as Inifor outputs only equidistant vertical data.
-       IF ( ANY( zu(1:nzt+1) /= force%zu_atmos(1:force%nzu) ) )  THEN
-          IF ( .NOT. force%interpolated )  THEN
-
-             DO  t = 0, 1
-                IF ( force_bound_l )  THEN
-                   CALL netcdf_data_input_interpolate( force%u_left(t,:,:),    &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%v_left(t,:,:),    &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%w_left(t,:,:),    &
-                                                       zw(nzb+1:nzt+1),        &
-                                                       force%zw_atmos )
-                   IF ( .NOT. neutral )                                        &
-                      CALL netcdf_data_input_interpolate( force%pt_left(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                   IF ( humidity )                                             &
-                      CALL netcdf_data_input_interpolate( force%q_left(t,:,:), &
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                ENDIF
-                IF ( force_bound_r )  THEN
-                   CALL netcdf_data_input_interpolate( force%u_right(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%v_right(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%w_right(t,:,:),   &
-                                                       zw(nzb+1:nzt+1),        &
-                                                       force%zw_atmos )
-                   IF ( .NOT. neutral )                                        &
-                      CALL netcdf_data_input_interpolate( force%pt_right(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                   IF ( humidity )                                             &
-                      CALL netcdf_data_input_interpolate( force%q_right(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                ENDIF
-                IF ( force_bound_n )  THEN
-                   CALL netcdf_data_input_interpolate( force%u_north(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%v_north(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%w_north(t,:,:),   &
-                                                       zw(nzb+1:nzt+1),        &
-                                                       force%zw_atmos )
-                   IF ( .NOT. neutral )                                        &
-                      CALL netcdf_data_input_interpolate( force%pt_north(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                   IF ( humidity )                                             &
-                      CALL netcdf_data_input_interpolate( force%q_north(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                ENDIF
-                IF ( force_bound_s )  THEN
-                   CALL netcdf_data_input_interpolate( force%u_south(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%v_south(t,:,:),   &
-                                                       zu(nzb+1:nzt+1),        &
-                                                       force%zu_atmos )
-                   CALL netcdf_data_input_interpolate( force%w_south(t,:,:),   &
-                                                       zw(nzb+1:nzt+1),        &
-                                                       force%zw_atmos )
-                   IF ( .NOT. neutral )                                        &
-                      CALL netcdf_data_input_interpolate( force%pt_south(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                   IF ( humidity )                                             &
-                      CALL netcdf_data_input_interpolate( force%q_south(t,:,:),&
-                                                          zu(nzb+1:nzt+1),     &
-                                                          force%zu_atmos )
-                ENDIF
-             ENDDO
-!
-!--          Note, no interpolation of top boundary. Just use initial value. 
-!--          No physical meaningful extrapolation possible if only one layer is
-!--          given. 
-
-             force%interpolated = .TRUE. 
-          ENDIF
-       ENDIF
-      
+     
 !
 !--    Calculate time interval of forcing data       
-       ddt_lsf = 1.0_wp / ( force%time(force%tind_p) - force%time(force%tind) )
+       ddt_lsf = 1.0_wp / ( nest_offl%time(nest_offl%tind_p) -                 &
+                            nest_offl%time(nest_offl%tind) )
 !
 !--    Calculate reziproke time past since last reference step. Please note, 
-!--    as simulated time is still not updated, the actual time here is 
-!--    simulated time + dt_3d
-       t_ref = simulated_time + dt_3d - force%time(force%tind)
-
-       IF ( force_bound_l )  THEN
-
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt+1
-                u(k,j,nxlg:nxl) = force%u_left(0,k,j) + ddt_lsf * t_ref *      &
-                         ( force%u_left(1,k,j) - force%u_left(0,k,j) ) *       &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxlg:nxl), 1 ) )
-             ENDDO
-          ENDDO
+!--    the time coordinate is still not updated, so that the actual time need
+!--    to be incremented by dt_3d. Moreover, note that the simulation time
+!--    passed since simulation start is time_since_reference_point, not 
+!--    simulated_time!
+       t_ref = time_since_reference_point + dt_3d -                            &
+                                            nest_offl%time(nest_offl%tind)
+                                            
+       IF ( bc_dirichlet_l )  THEN
 
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-                w(k,j,nxlg:nxl-1) = force%w_left(0,k,j) + ddt_lsf * t_ref *    &
-                         ( force%w_left(1,k,j) - force%w_left(0,k,j) ) *       &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxlg:nxl-1), 3 ) )
+                u(k,j,nxlg:nxl) = nest_offl%u_left(0,k,j) + ddt_lsf * t_ref  * &
+                       ( nest_offl%u_left(1,k,j) - nest_offl%u_left(0,k,j) ) * &
+                         MERGE( 1.0_wp, 0.0_wp,                                &
+                                BTEST( wall_flags_0(k,j,nxlg:nxl), 1 ) )
+             ENDDO
+          ENDDO
+
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt-1
+                w(k,j,nxlg:nxl-1) = nest_offl%w_left(0,k,j) + ddt_lsf * t_ref *&
+                       ( nest_offl%w_left(1,k,j) - nest_offl%w_left(0,k,j) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                &
+                                BTEST( wall_flags_0(k,j,nxlg:nxl-1), 3 ) )
              ENDDO
           ENDDO
 
           DO  j = nysv, nyn
-             DO  k = nzb+1, nzt+1
-                v(k,j,nxlg:nxl-1) = force%v_left(0,k,j) + ddt_lsf * t_ref *    &
-                         ( force%v_left(1,k,j) - force%v_left(0,k,j) ) *       &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxlg:nxl-1), 2 ) )
+             DO  k = nzb+1, nzt
+                v(k,j,nxlg:nxl-1) = nest_offl%v_left(0,k,j) + ddt_lsf * t_ref *&
+                       ( nest_offl%v_left(1,k,j) - nest_offl%v_left(0,k,j) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                &
+                                BTEST( wall_flags_0(k,j,nxlg:nxl-1), 2 ) )
              ENDDO
           ENDDO
@@ -418,8 +335,8 @@
           IF ( .NOT. neutral )  THEN
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt+1
-                   pt(k,j,nxlg:nxl-1) = force%pt_left(0,k,j) + ddt_lsf *       &
-                                                                  t_ref   *    &
-                       ( force%pt_left(1,k,j) - force%pt_left(0,k,j) )
+                DO  k = nzb+1, nzt
+                   pt(k,j,nxlg:nxl-1) = nest_offl%pt_left(0,k,j) + ddt_lsf *   &
+                                                                   t_ref   *   &
+                       ( nest_offl%pt_left(1,k,j) - nest_offl%pt_left(0,k,j) )
  
                 ENDDO
@@ -429,8 +346,8 @@
           IF ( humidity )  THEN
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt+1
-                   q(k,j,nxlg:nxl-1) = force%q_left(0,k,j) + ddt_lsf   *       &
-                                                                  t_ref   *    &
-                       ( force%q_left(1,k,j) - force%q_left(0,k,j) )
+                DO  k = nzb+1, nzt
+                   q(k,j,nxlg:nxl-1) = nest_offl%q_left(0,k,j) + ddt_lsf   *   &
+                                                                 t_ref     *   &
+                       ( nest_offl%q_left(1,k,j) - nest_offl%q_left(0,k,j) )
  
                 ENDDO
@@ -440,30 +357,30 @@
        ENDIF
 
-       IF ( force_bound_r )  THEN
-
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt+1
-                u(k,j,nxr+1:nxrg) = force%u_right(0,k,j) + ddt_lsf * t_ref *   &
-                        ( force%u_right(1,k,j) - force%u_right(0,k,j) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxr+1:nxrg), 1 ) )
-
-             ENDDO
-          ENDDO
+       IF ( bc_dirichlet_r )  THEN
+
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-                w(k,j,nxr+1:nxrg) = force%w_right(0,k,j) + ddt_lsf * t_ref *   &
-                        ( force%w_right(1,k,j) - force%w_right(0,k,j) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxr+1:nxrg), 3 ) )
+                u(k,j,nxr+1:nxrg) = nest_offl%u_right(0,k,j) + ddt_lsf * t_ref *&
+                      ( nest_offl%u_right(1,k,j) - nest_offl%u_right(0,k,j) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                 &
+                                BTEST( wall_flags_0(k,j,nxr+1:nxrg), 1 ) )
+
+             ENDDO
+          ENDDO
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt-1
+                w(k,j,nxr+1:nxrg) = nest_offl%w_right(0,k,j) + ddt_lsf * t_ref *&
+                      ( nest_offl%w_right(1,k,j) - nest_offl%w_right(0,k,j) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                 &
+                                BTEST( wall_flags_0(k,j,nxr+1:nxrg), 3 ) )
              ENDDO
           ENDDO
 
           DO  j = nysv, nyn
-             DO  k = nzb+1, nzt+1
-                v(k,j,nxr+1:nxrg) = force%v_right(0,k,j) + ddt_lsf * t_ref *   &
-                        ( force%v_right(1,k,j) - force%v_right(0,k,j) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,j,nxr+1:nxrg), 2 ) )
+             DO  k = nzb+1, nzt
+                v(k,j,nxr+1:nxrg) = nest_offl%v_right(0,k,j) + ddt_lsf * t_ref *&
+                      ( nest_offl%v_right(1,k,j) - nest_offl%v_right(0,k,j) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                 &
+                                BTEST( wall_flags_0(k,j,nxr+1:nxrg), 2 ) )
              ENDDO
           ENDDO
@@ -471,8 +388,8 @@
           IF ( .NOT. neutral )  THEN
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt+1
-                   pt(k,j,nxr+1:nxrg) = force%pt_right(0,k,j) + ddt_lsf *      &
-                                                                  t_ref   *    &
-                     ( force%pt_right(1,k,j) - force%pt_right(0,k,j) )
+                DO  k = nzb+1, nzt
+                   pt(k,j,nxr+1:nxrg) = nest_offl%pt_right(0,k,j) + ddt_lsf *  &
+                                                                    t_ref   *  &
+                     ( nest_offl%pt_right(1,k,j) - nest_offl%pt_right(0,k,j) )
  
                 ENDDO
@@ -482,8 +399,8 @@
           IF ( humidity )  THEN
              DO  j = nys, nyn
-                DO  k = nzb+1, nzt+1
-                   q(k,j,nxr+1:nxrg) = force%q_right(0,k,j) + ddt_lsf   *      &
-                                                                  t_ref   *    &
-                       ( force%q_right(1,k,j) - force%q_right(0,k,j) )
+                DO  k = nzb+1, nzt
+                   q(k,j,nxr+1:nxrg) = nest_offl%q_right(0,k,j) + ddt_lsf   *  &
+                                                                    t_ref   *  &
+                       ( nest_offl%q_right(1,k,j) - nest_offl%q_right(0,k,j) )
  
                 ENDDO
@@ -493,20 +410,20 @@
        ENDIF
 
-       IF ( force_bound_s )  THEN
-
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt+1
-                v(k,nysg:nys,i)   = force%v_south(0,k,i) + ddt_lsf * t_ref *   &
-                        ( force%v_south(1,k,i) - force%v_south(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,nysg:nys,i), 2 ) )
-             ENDDO
-          ENDDO
+       IF ( bc_dirichlet_s )  THEN
 
           DO  i = nxl, nxr
              DO  k = nzb+1, nzt
-                w(k,nysg:nys-1,i) = force%w_south(0,k,i) + ddt_lsf * t_ref *   &
-                        ( force%w_south(1,k,i) - force%w_south(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
+                v(k,nysg:nys,i)   = nest_offl%v_south(0,k,i) + ddt_lsf * t_ref *&
+                      ( nest_offl%v_south(1,k,i) - nest_offl%v_south(0,k,i) )  *&
+                         MERGE( 1.0_wp, 0.0_wp,                                 &
+                                BTEST( wall_flags_0(k,nysg:nys,i), 2 ) )
+             ENDDO
+          ENDDO
+
+          DO  i = nxl, nxr
+             DO  k = nzb+1, nzt-1
+                w(k,nysg:nys-1,i) = nest_offl%w_south(0,k,i) + ddt_lsf * t_ref  *&
+                        ( nest_offl%w_south(1,k,i) - nest_offl%w_south(0,k,i) ) *&
+                           MERGE( 1.0_wp, 0.0_wp,                                &
                                   BTEST( wall_flags_0(k,nysg:nys-1,i), 3 ) )
              ENDDO
@@ -514,8 +431,8 @@
 
           DO  i = nxlu, nxr
-             DO  k = nzb+1, nzt+1
-                u(k,nysg:nys-1,i) = force%u_south(0,k,i) + ddt_lsf * t_ref *   &
-                        ( force%u_south(1,k,i) - force%u_south(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
+             DO  k = nzb+1, nzt
+                u(k,nysg:nys-1,i) = nest_offl%u_south(0,k,i) + ddt_lsf * t_ref  *&
+                        ( nest_offl%u_south(1,k,i) - nest_offl%u_south(0,k,i) ) *&
+                           MERGE( 1.0_wp, 0.0_wp,                                &
                                   BTEST( wall_flags_0(k,nysg:nys-1,i), 1 ) )
              ENDDO
@@ -524,8 +441,8 @@
           IF ( .NOT. neutral )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb+1, nzt+1
-                   pt(k,nysg:nys-1,i) = force%pt_south(0,k,i) + ddt_lsf *      &
-                                                                  t_ref   *    &
-                     ( force%pt_south(1,k,i) - force%pt_south(0,k,i) )
+                DO  k = nzb+1, nzt
+                   pt(k,nysg:nys-1,i) = nest_offl%pt_south(0,k,i) + ddt_lsf *  &
+                                                                    t_ref   *  &
+                     ( nest_offl%pt_south(1,k,i) - nest_offl%pt_south(0,k,i) )
  
                 ENDDO
@@ -535,8 +452,8 @@
           IF ( humidity )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb+1, nzt+1
-                   q(k,nysg:nys-1,i) = force%q_south(0,k,i) + ddt_lsf   *      &
-                                                                  t_ref   *    &
-                       ( force%q_south(1,k,i) - force%q_south(0,k,i) )
+                DO  k = nzb+1, nzt
+                   q(k,nysg:nys-1,i) = nest_offl%q_south(0,k,i) + ddt_lsf   *  &
+                                                                    t_ref   *  &
+                       ( nest_offl%q_south(1,k,i) - nest_offl%q_south(0,k,i) )
  
                 ENDDO
@@ -546,19 +463,19 @@
        ENDIF
 
-       IF ( force_bound_n )  THEN
-
-          DO  i = nxl, nxr
-             DO  k = nzb+1, nzt+1
-                v(k,nyn+1:nyng,i)   = force%v_north(0,k,i) + ddt_lsf * t_ref * &
-                        ( force%v_north(1,k,i) - force%v_north(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
-                                  BTEST( wall_flags_0(k,nyn+1:nyng,i), 2 ) )
-             ENDDO
-          ENDDO
+       IF ( bc_dirichlet_n )  THEN
+
           DO  i = nxl, nxr
              DO  k = nzb+1, nzt
-                w(k,nyn+1:nyng,i) = force%w_north(0,k,i) + ddt_lsf * t_ref *   &
-                        ( force%w_north(1,k,i) - force%w_north(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
+                v(k,nyn+1:nyng,i)   = nest_offl%v_north(0,k,i) + ddt_lsf * t_ref *&
+                        ( nest_offl%v_north(1,k,i) - nest_offl%v_north(0,k,i) )  *&
+                           MERGE( 1.0_wp, 0.0_wp,                                 &
+                                  BTEST( wall_flags_0(k,nyn+1:nyng,i), 2 ) )
+             ENDDO
+          ENDDO
+          DO  i = nxl, nxr
+             DO  k = nzb+1, nzt-1
+                w(k,nyn+1:nyng,i) = nest_offl%w_north(0,k,i) + ddt_lsf * t_ref  *&
+                        ( nest_offl%w_north(1,k,i) - nest_offl%w_north(0,k,i) ) *&
+                           MERGE( 1.0_wp, 0.0_wp,                                &
                                   BTEST( wall_flags_0(k,nyn+1:nyng,i), 3 ) )
              ENDDO
@@ -566,8 +483,8 @@
 
           DO  i = nxlu, nxr
-             DO  k = nzb+1, nzt+1
-                u(k,nyn+1:nyng,i) = force%u_north(0,k,i) + ddt_lsf * t_ref *   &
-                        ( force%u_north(1,k,i) - force%u_north(0,k,i) ) *      &
-                           MERGE( 1.0_wp, 0.0_wp,                              &
+             DO  k = nzb+1, nzt
+                u(k,nyn+1:nyng,i) = nest_offl%u_north(0,k,i) + ddt_lsf * t_ref  *&
+                        ( nest_offl%u_north(1,k,i) - nest_offl%u_north(0,k,i) ) *&
+                           MERGE( 1.0_wp, 0.0_wp,                                &
                                   BTEST( wall_flags_0(k,nyn+1:nyng,i), 1 ) )
 
@@ -577,8 +494,8 @@
           IF ( .NOT. neutral )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb+1, nzt+1
-                   pt(k,nyn+1:nyng,i) = force%pt_north(0,k,i) + ddt_lsf *      &
-                                                                  t_ref   *    &
-                     ( force%pt_north(1,k,i) - force%pt_north(0,k,i) )
+                DO  k = nzb+1, nzt
+                   pt(k,nyn+1:nyng,i) = nest_offl%pt_north(0,k,i) + ddt_lsf *  &
+                                                                    t_ref   *  &
+                     ( nest_offl%pt_north(1,k,i) - nest_offl%pt_north(0,k,i) )
  
                 ENDDO
@@ -588,8 +505,8 @@
           IF ( humidity )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb+1, nzt+1
-                   q(k,nyn+1:nyng,i) = force%q_north(0,k,i) + ddt_lsf   *      &
-                                                                  t_ref   *    &
-                       ( force%q_north(1,k,i) - force%q_north(0,k,i) )
+                DO  k = nzb+1, nzt
+                   q(k,nyn+1:nyng,i) = nest_offl%q_north(0,k,i) + ddt_lsf   *  &
+                                                                    t_ref   *  &
+                       ( nest_offl%q_north(1,k,i) - nest_offl%q_north(0,k,i) )
  
                 ENDDO
@@ -600,12 +517,9 @@
 !
 !--    Top boundary. 
-!--    Please note, only map Inifor data on model top in case the numeric is
-!--    identical to the Inifor grid. At the top boundary an extrapolation is 
-!--    not possible. 
        DO  i = nxlu, nxr
           DO  j = nys, nyn
-             u(nzt+1,j,i) = force%u_top(0,j,i) + ddt_lsf * t_ref *             &
-                        ( force%u_top(1,j,i) - force%u_top(0,j,i) ) *          &
-                           MERGE( 1.0_wp, 0.0_wp,                             &
+             u(nzt+1,j,i) = nest_offl%u_top(0,j,i) + ddt_lsf * t_ref *         &
+                        ( nest_offl%u_top(1,j,i) - nest_offl%u_top(0,j,i) ) *  &
+                           MERGE( 1.0_wp, 0.0_wp,                              &
                                   BTEST( wall_flags_0(nzt+1,j,i), 1 ) )
           ENDDO
@@ -614,6 +528,6 @@
        DO  i = nxl, nxr
           DO  j = nysv, nyn
-             v(nzt+1,j,i) = force%v_top(0,j,i) + ddt_lsf * t_ref *             &
-                        ( force%v_top(1,j,i) - force%v_top(0,j,i) ) *          &
+             v(nzt+1,j,i) = nest_offl%v_top(0,j,i) + ddt_lsf * t_ref *         &
+                        ( nest_offl%v_top(1,j,i) - nest_offl%v_top(0,j,i) ) *  &
                            MERGE( 1.0_wp, 0.0_wp,                              &
                                   BTEST( wall_flags_0(nzt+1,j,i), 2 ) )
